import pandas as pd
import numpy as np

class DataProcess:
    def __init__(self) -> None:
        self.data: pd.DataFrame = ...
        self.attribs: str = ...
        
        self.variance: float = ...
        self.covariance: float = ...
        self.correlation: float = ...
        
    def set_attribs(self, data: pd.DataFrame, attribs: tuple = ...) -> ...:
        self.data = data
        self.attribs = attribs
        return self

    def calculate(self, args: tuple = ...) -> ...:
        (
            attrib1,
            attrib2
        ) = self.attribs
        
        self.variance: float = np.var(self.data[attrib1]), np.var(self.data[attrib2]) if "variance" in args else ''
        self.covariance: float = self.data[attrib1].cov(self.data[attrib2]) if "covariance" in args else ''
        self.correlation: float = self.data[attrib1].corr(self.data[attrib2]) if "correlation" in args else ''
        return self
    
    def show_result(self) -> pd.DataFrame:
        result_dictionary: dict = {
            "Variance": [self.variance[0], self.variance[1]],
            "Covariance": [self.covariance, ''],
            "Correlation": [self.correlation, '']
        }
        
        res_df = pd.DataFrame(result_dictionary)
        res_df
        return res_df
        